# 
# TAOF, the general purpose TCP fuzzer.
# Copyright (C) 2006 Rodrigo Marcos
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# 

import xml.dom.minidom # for xml input/output
import socket
import asyncore
import sys
import os # for folder creation
import time #for folder creation and sleep

from twisted.internet import gtk2reactor
gtk2reactor.install()

from twisted.protocols import portforward

import gtk


overflowstrings = ["A" * 33, "A" * 128, "A" * 240, "A" * 255, "A" * 256, "A" * 257, "A" * 420, "A" * 511, "A" * 512, "A" * 1023, "A" * 1024, "A" * 2047, "A" * 2048, "A" * 4096, "A" * 4097, "A" * 5000, "A" * 10000, "A" * 20000, "A" * 32762, "A" * 32763, "A" * 32764, "A" * 32765, "A" * 32766, "A" * 32767, "A" * 32768, "A" * 65534, "A" * 65535, "A" * 65536]
formatstrings   = ["%s" * 4, "%s" * 8, "%s" * 15, "%s" * 30, "%x" * 1024, "%n" * 1025 , "%s" * 2048, "%s%n%x%d" * 5000, "%s" * 30000, "%s" * 40000, "%.1024d", "%.2048d", "%.4096d", "%.8200d", "%99999999999s", "%99999999999d", "%99999999999x", "%99999999999n", "%99999999999s" * 1000, "%99999999999d" * 1000, "%99999999999x" * 1000, "%99999999999n" * 1000, "%08x" * 100, "%%20s" * 1000,"%%20x" * 1000,"%%20n" * 1000,"%%20d" * 1000, "%#0123456x%08x%x%s%p%n%d%o%u%c%h%l%q%j%z%Z%t%i%e%g%f%a%C%S%08x%%#0123456x%%x%%s%%p%%n%%d%%o%%u%%c%%h%%l%%q%%j%%z%%Z%%t%%i%%e%%g%%f%%a%%C%%S%%08x"]
integerstrings  = [-1, 0, 0x100, 0x1000, 0x10000, 0x100000, 0x3fffffff, 0x7ffffffe, 0x7fffffff, 0x80000000, 0xfffffffe, 0xffffffff]


####################################
####################################

def server_dataReceived(self, data):
	#print 'server recieved data:', data
	context["REQUEST_COUNTER"] += 1	
	context["logger"].log_request(context["REQUEST_COUNTER"], data)				#log the actual raw request
	context["xmllog"].add_request(context["xmldoc"], context["xmlconv"], str(context["REQUEST_COUNTER"])) 	#log into xml file
		
	portforward.Proxy.dataReceived(self, data)

portforward.ProxyServer.dataReceived = server_dataReceived

def client_dataReceived(self, data):
	#print 'client received data:', data
	#context["logger"].log_response(context["REQUEST_COUNTER"], data)
	portforward.Proxy.dataReceived(self, data)

portforward.ProxyClient.dataReceived = client_dataReceived


####################################
####################################
class xmlfuzz:

	def __init__(self):
		self.file = "fuzz.xml"

	def create_document(self,localhost, localport, desthost, destport):
		doc=xml.dom.minidom.Document()
		conversation_element = doc.createElementNS("", "conversation")
		conversation_element.setAttributeNS("","local_host", localhost)
		conversation_element.setAttributeNS("","local_port", localport)
		conversation_element.setAttributeNS("","dest_host", desthost)
		conversation_element.setAttributeNS("","dest_port", destport)
		conversation_element.setAttributeNS("","time",time.strftime("%H:%M:%S"))
		doc.appendChild(conversation_element)
		return doc, conversation_element
	
	def get_document(self, name="fuzz.xml"):
		doc = xml.dom.minidom.parse(name)
		return doc,  doc.getElementsByTagName("conversation")
	
	def get_network_info(self, doc):
		conversation_element = doc.getElementsByTagName("conversation")
		return conversation_element[0].attributes["local_host"].value, conversation_element[0].attributes["local_port"].value,conversation_element[0].attributes["dest_host"].value, conversation_element[0].attributes["dest_port"].value
		
	def add_request(self, doc, conversation_element, request_ID):
		request_element = doc.createElementNS("", "request")
		request_element.setAttributeNS("","ID",str(request_ID))
		request_element.setAttributeNS("","time",time.strftime("%H:%M:%S"))
		request_element.setAttributeNS("","as_is","0")
		conversation_element.appendChild(request_element)
		return request_element
	
#	def set_request_attributes(self, request_element, request_ignore, request_fuzz):
#		request_element.setAttributeNS("","ignore",str(request_ignore))
#		request_element.setAttributeNS("","fuzzing",str(request_fuzz))
	
	def add_as_is(self, doc, request_element):
		request_element.setAttributeNS("", "as_is", "1")
		return request_element
		
	def del_as_is(self, doc, request_element):
		request_element.setAttributeNS("", "as_is", "0")
		return request_element
		
	def add_fuzz(self, doc, request_element, fuzz_ID, fuzz_from, fuzz_to, fuzz_bo, fuzz_fs, fuzz_obo):
		fuzz_element = doc.createElementNS("", "fuzz")
		fuzz_element.setAttributeNS("", "ID", str(fuzz_ID))
		fuzz_element.setAttributeNS("", "from", str(fuzz_from))
		fuzz_element.setAttributeNS("", "to", str(fuzz_to))
		fuzz_element.setAttributeNS("", "bo", str(fuzz_bo))
		fuzz_element.setAttributeNS("", "fs", str(fuzz_fs))
		fuzz_element.setAttributeNS("", "obo", str(fuzz_obo))
		request_element.appendChild(fuzz_element)
		return fuzz_element
	
	def write_to_screen(self, doc):
		print doc.toxml()

	def write_to_file(self, doc):
		file_object = open(self.file, "w")
		doc.writexml(file_object)
		file_object.close()

	def get_requests(self, doc):
		myrequests = doc.getElementsByTagName('request')
		return myrequests

	def get_request(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		try:
			return myrequests[id]
		except:
			return False
			
	def get_number_requests(self, doc):
		myrequests = doc.getElementsByTagName('request')
		return len(myrequests)
	
	def ignore_request(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		return myrequests[id].attributes["ignore"].value
	
	def fuzz_bo(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["bo"].value
	
	def fuzz_fs(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["fs"].value

	def fuzz_int(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["obo"].value
	
	def get_from_to(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["from"].value, myfuzz[idfuzz].attributes["to"].value
	
	def get_number_fuzz(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		return len (myrequests[id].getElementsByTagName("fuzz"))

	def get_fuzzs(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		return myrequests[id].getElementsByTagName("fuzz")
		
#############################################################################
#
# Fuzzer class 
#
#############################################################################

class fuzzer:
	

	def send_as_is(self):
	#This function sends "as_is" requests
		for requestid in range(0, context["xmllog"].get_number_requests(context["xmldoc"])):
			myrequest = context["xmllog"].get_request(context["xmldoc"],requestid)
			if myrequest.attributes["as_is"].value == "1":
				try:
					current_request = context["logger"].read_request(requestid+1)
					self.remoteserver.send(current_request)
					self.recv_timeout()
				except:
#					print str(sys.exc_info()[0])
					return "0"
		return "1"					
	
	
	def recv_timeout(self):
		self.remoteserver.setblocking(0)
		total_data=[];data='';begin=time.time()
		while 1:
			if total_data and time.time()-begin > context["timeout"]:
				break
			elif time.time()-begin>context["timeout"]*2:
				break
			try:
				data=self.remoteserver.recv(1024)
				if data:
					total_data.append(data)
					begin=time.time()
				else:
					while gtk.events_pending():	# Run pending events
						gtk.main_iteration_do(False)
					time.sleep(0.1)
			except:
				pass
		return ''.join(total_data)		

	def fuzz_loop(self, signatures, first_part, last_part, isnumber):

		for sg in signatures:
			#time.sleep(context["wait"]) # Wait for each request
			if context["stopfuzzing"]==1: # The user decided to stop fuzzing
				break
			while gtk.events_pending():	# Run pending events
				gtk.main_iteration_do(False)
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),'*')	
			#print "[*]" + time.strftime("%H:%M:%S")
			try:
				if isnumber:
					fuzzed_request = first_part + str(sg) + last_part
				else:
					fuzzed_request = first_part + sg + last_part

				if context["debug"]:
					self.file_object.write("\n*************************<REQUEST>***********************\n")
					self.file_object.write(fuzzed_request)
					self.file_object.write("\n*************************<REQUEST/>***********************\n")

				self.remoteserver.send(fuzzed_request) # Send...
				results = self.recv_timeout() # and receive...
				
				if results=="": # This usually means that the remote server closed the connection
					res = self.reconnect()
					
					#Let's handle the reconnection.
					if res=='1':
						self.remoteserver.send(fuzzed_request)
						results = self.recv_timeout()
						if context["debug"]:
							self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE>+++++++++++++++++++++++++\n")
							self.file_object.write(results)															
							self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE/>+++++++++++++++++++++++++\n")
					else:
						if res=='-1': # We need to exit...(socket issue)
							gtk.main_quit()
							sys.exit(-1)
						if res=='-2': # This might be good (connection issue, the service might have died)
							if context["debug"]:
								self.file_object.write("\n*************************<BUFFER>***********************\n")
								self.file_object.write(fuzzed_request)
								self.file_object.write("\n*************************<BUFFER/>***********************\n")
							#Let's try to wait a big while (maybe the service comes back)
							#If that doesn't happen, it means that this is the end of the fuzzing session
							time.sleep(context["wait_reconnection"]*5)
							res2 = self.reconnect()
							if res2!='1':
								if context["debug"]:
									self.file_object.write("\n[*] I have to give up. I can not connect to the server" )
								context["stopfuzzing"]=1
								#gtk.main_quit()
								#sys.exit(-1)
				else: # everything went ok
					if context["debug"]:
						self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE>+++++++++++++++++++++++++\n")
						self.file_object.write(results)															
						self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE/>+++++++++++++++++++++++++\n")
						
				
			except socket.error, msg:
				if context["debug"]:
					self.file_object.write("\n----------------------------<SOCKET EXCEPTION>-------------------------\n")
					logtemp = "Socket.error: " + str(msg)
					self.file_object.write(logtemp)		
					self.file_object.write("\n----------------------------<SOCKET EXCEPTION/>-------------------------\n")
				self.reconnect()
				
			except:
				if context["debug"]:
					self.file_object.write("\n----------------------------<EXCEPTION>-------------------------\n")
					self.file_object.write(str(sys.exc_info()[1]) )#+ " - " + sys.exc_info()[1])
					self.file_object.write("\n----------------------------<EXCEPTION/>-------------------------\n")
				self.reconnect()

	def reconnect(self):
		try:		
			self.remoteserver = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		except:
			pass
		
		exit_loop = 0
		for i in range(0,5):

			try:								
				self.remoteserver.connect((context["dest_host"], int(context["dest_port"])))
				exit_loop=1
			except socket.error, desc:
				#print desc
				if desc[0]==106:
					exit_loop=1	# Already connected
				else:
					logtemp = "\n[*] It was not possible to connect to " + context["dest_host"] + ":" + context["dest_port"] + ". It might be down. Retrying now..."
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					time.sleep(context["wait_reconnection"]) # Let's wait a little bit
			except:
				#print str(sys.exc_info()[1])
				logtemp = "\n[*] It was not possible to connect to " + context["dest_host"] + ":" + context["dest_port"] + ". It might be down. Retrying now..."
				context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
				time.sleep(context["wait_reconnection"]) # Let's wait a little bit
			if exit_loop==1:
				break

		if i==4: # Ooops, we could not connect to the server. The service might have died
			logtemp = "\n[*] I could connect to the server. I might killed the service (which is good!)."
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
			return '-2'
			
		result = self.send_as_is()
	#	if context["debug"]:
	#		logtemp = "Authentication result:" + result + "\n"
	#		self.file_object.write(logtemp)
			
		return '1'
				
	def run(self):
	# This is the main loop for fuzzing
			
		if context["debug"]:
			self.file_object = open("debugging" , "w")
				
		logtemp = "Starting fuzzing session against " + context["dest_host"] + ":" + context["dest_port"]  + " - " + time.strftime("%H:%M:%S")##########################
		self.file_object.write(logtemp)
		context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
		context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"Check 'debugging' file for further information" + '\n\n')
		#initialization

		self.reconnect() # it establishes the connection to the server
		
		#loops though all the requests					
		for requestid in range(0, context["xmllog"].get_number_requests(context["xmldoc"])):

			if context["stopfuzzing"]==1: # The user decided to stop fuzzing
				break
			current_request = context["logger"].read_request(requestid+1)
			logtemp = "Fuzzing request: " + str(requestid)
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
			logtemp = "	Number of fuzzing points: " + str(context["xmllog"].get_number_fuzz(context["xmldoc"], requestid))
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')

			if context["debug"]:
				logtemp = "Fuzzing request: " + str(requestid) + "\n"
				self.file_object.write(logtemp)
				logtemp = "	Number of fuzzing points: " + str(context["xmllog"].get_number_fuzz(context["xmldoc"],requestid)) + "\n"
				self.file_object.write(logtemp)
			
			#It goes through each of the fuzzing points on the current request
			for fuzzid in range (0, context["xmllog"].get_number_fuzz(context["xmldoc"], requestid)):
				if context["stopfuzzing"]==1: # The user decided to stop fuzzing
					break

				ffrom, fto = context["xmllog"].get_from_to(context["xmldoc"], requestid, fuzzid)
				#it gest the boundaries of the fuzzing point
								
				print "Testing fuzzing point ", fuzzid, ": (", ffrom, " - ", fto, ")"
				if context["debug"]:
					logtemp = "Testing fuzzing point " + str(fuzzid) + ": (" + ffrom + " - " + fto + ")"
					self.file_object.write(logtemp)

				ffrom = int(ffrom)
				fto = int(fto)

				first_part = current_request[:ffrom]
				last_part = current_request[fto:]
				
				#fuzzing buffer overflows
				if context["xmllog"].fuzz_bo(context["xmldoc"], requestid, fuzzid)=='1':
					logtemp = "\n + Buffer overflows"
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')

					self.fuzz_loop(overflowstrings, first_part, last_part, 0)
				if context["stopfuzzing"]==1: # The user decided to stop fuzzing
					break
			
				#fuzzing format strings								 
				if context["xmllog"].fuzz_fs(context["xmldoc"], requestid, fuzzid)=='1':
					logtemp = "\n + Format Strings"
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					
					self.fuzz_loop(formatstrings, first_part, last_part, 0)
				
				if context["stopfuzzing"]==1: # The user decided to stop fuzzing
					break
	
				#fuzzing integer strings
				if context["xmllog"].fuzz_int(context["xmldoc"], requestid, fuzzid)=='1':
					logtemp = "\n + Integer Overflows"
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					
					self.fuzz_loop(integerstrings, first_part, last_part, 1)

				if context["stopfuzzing"]==1: # The user decided to stop fuzzing
					break

		if context["debug"]:
			self.file_object.close()
		if context["stopfuzzing"]==1: # The user decided to stop fuzzing
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"\n[*] Fuzzing session finished by user.\n")
		else:
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"\n[*] Fuzzing session finished.\n")

#############################################################################
#
# Logger
#
#############################################################################


class Log:
	

	def __init__(self, path=0):
		#self.folder = "." + time
		if path:
			self.folder = path
			try:
				os.chdir(self.folder)
			except:
				sys.stderr.write('Problem changing folder.\n')
			
		else:
			self.folder = "fuzzing_session-" + time.strftime('%j-%H.%M.%S')
			try:
				os.mkdir(self.folder)
				os.chdir(self.folder)
			except:
				sys.stderr.write('Problem creating logging folder.\n')

	def end(self):
		os.chdir("../")
#		os.rmdir(".fuzzing")

	def log_request(self, ID, request):
		file_object = open(str(ID) + "req" , "w")
		file_object.write(request)
		file_object.close()

	def log_response(self, ID, response):
		file_object = open(str(ID) + "res" , "w")
		file_object.write(response)
		file_object.close()

	def read_request(self, ID):
		file_object = open(str(ID) + "req" , "r")
		request = file_object.read()
		file_object.close()
		return request

	def read_response(self, ID):
		file_object = open(str(ID) + "res" , "r")
		response = file_object.read()
		file_object.close()
		return response

context = {}

#context["local_port"] = "3306"
#context["dest_host"] = "172.25.0.156" # This is temp solution.
#context["dest_port"] = "8700"					# This is a temp solution
#context["dest_port"] = "3306"					# This is a temp solution


context["RECV_BUFFER_SIZE"] = 8192
context["REQUEST_COUNTER"] = 0
context["debug"] = 1
context["timeout"] = 1 # (seconds) timeout for receiving response from server
context["wait"] = 0.2 # (seconds) waiting time between requests 
context["wait_reconnection"] = 0.5 # (seconds) waiting time between reconections 
context["stopfuzzing"]=0


		