#!/usr/bin/env python
# 
# TAOF, the general purpose TCP fuzzer.
# Copyright (C) 2006 Rodrigo Marcos
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# 




		
#----------------------------------------------------------------------
# guifuzzer.py
#----------------------------------------------------------------------

import fuzzutils

from twisted.internet import reactor
import gtk.glade
import pygtk
import sys
import gtk
import gobject
import asyncore
import binascii 



(
    COLUMN_ID,
    COLUMN_TIME
) = range(2)

(
    COLUMN_ID,
    COLUMN_FROM,
    COLUMN_TO
) = range(3)


VERSION = '0.1'

class taof:

	current_request = 1
	cb_dict = {}
	widget_list = [
			'Settings',
			'localserver',
			'localport',
			'remoteserver',
			'remoteport',
			'OK',
			'usessl',
			'Main',
			'settings',
			'listen', # Start on Dataretrieval
			'stoplisten', # stop listen on Dataretrieval
			'fuzz',
			'ignore',
			'fuzz', # start fuzzing on fuzzing dialog
			'stopfuzzingbutton', # stop fuzzing on the fuzzing dialog
			'from',
			'to',
			'apply',
			'scrolledwindow4',
			'requesttext',
			'statusbar1',
			'FuzzPoints',
			'asciiview',
			'hexview',
			'txtFrom',
			'txtTo',
			'setfuzz', # set fuzzing points button in main
			'FuzzPoints',
			'scrolledwindow7',
			'add_fuzz',
			'del_fuzz',
			'open',
			'filechooserdialog1',
			'cbasis',
			'ok_fuzz',
			'request',
			'aboutdialog1', # about dialog
			'about1', # about menu
			'checkstackheap', # checkbox heap in fuzzingpoints
			'checkstring', # checkbox string on fuzzingpooints
			'checkinteger', # checkbox integer on fuzzingpoints
			'dataretrievalbutton', # dataretrieval button on main dialog
			'fuzzingbutton', # fuzzing button on main dialog
			'fuzzingdialog', # fuzzing dialog
			'dataretrievaldialog', # dataretrieval dialog
			'dataretrievalok', # hide dataretrieval dialog
			'open1', #menu
			'quit1', #menu
			'help1', #menu
			'listeninglog', # log on dataretrieval
			'fuzzinglog', # log on fuzzingdialog
			'helpdialog', # help dialog
		
]

	top_window = 'Main'

#----------------------------------------------------------------------

	def __init__(self):
	
		filename = 'fuzzer.glade'
		self.xml = gtk.glade.XML(filename)

 		self.init()

#----------------------------------------------------------------------

	def init(self):
		
		
		self.widgets = {}
		for w in self.widget_list:
			self.widgets[w] = self.xml.get_widget(w)
		
		self.create_fuzzer_points_list()
		
		item = self.widgets['about1']
		item.connect('activate', self.on_about_clicked)

		item = self.widgets['help1']
		item.connect('activate', self.on_help1_clicked)

		item = self.widgets['settings']
		item.connect('clicked', self.on_settings_clicked)

		item = self.widgets['listen']
		item.connect('clicked', self.on_listen_clicked)

		item = self.widgets['stoplisten']
		item.connect('clicked', self.on_stoplisten_clicked)

		item = self.widgets['fuzz']
		item.connect('clicked', self.on_fuzz_clicked)

		item = self.widgets['stopfuzzingbutton']
		item.connect('clicked', self.on_stopfuzzingbutton_clicked)

		item = self.widgets['dataretrievalbutton']
		item.connect('clicked', self.on_dataretrievalbutton_clicked)

		item = self.widgets['fuzzingbutton']
		item.connect('clicked', self.on_fuzzingbutton_clicked)
		
		item = self.widgets['Main']
		item.connect('hide', self.on_Main_destroy_event)

		item = self.widgets['quit1']
		item.connect('activate', self.on_Main_destroy_event)

		item = self.widgets['Main']
		item.connect('destroy_event', self.on_Main_destroy_event)

		item = self.widgets['OK']
		item.connect('clicked', self.on_OK_clicked)

		item = self.widgets['setfuzz']
		item.connect('clicked', self.on_setfuzz_clicked)

		item = self.widgets['asciiview']
		item.connect('button_release_event', self.on_button_release)
		
		item = self.widgets['FuzzPoints']
		item.connect('delete_event', self.on_fuzzing_points_delete_event)

		item = self.widgets['Settings']
		item.connect('delete_event', self.on_settings_delete_event)

		item = self.widgets['dataretrievaldialog']
		item.connect('delete_event', self.on_dataretrievaldialog_delete_event)

		item = self.widgets['dataretrievalok']
		item.connect('clicked', self.on_dataretrievaldialog_delete_event)

		item = self.widgets['fuzzingdialog']
		item.connect('delete_event', self.on_fuzzingdialog_delete_event)

		item = self.widgets['aboutdialog1']
		item.connect('delete_event', self.on_aboutdialog_delete_event)
		
		item = self.widgets['helpdialog']
		item.connect('delete_event', self.on_helpdialog_delete_event)

		item = self.widgets['FuzzPoints']
		item.connect('show', self.fuzz_points_show)

		item = self.widgets['add_fuzz']
		item.connect('clicked', self.add_fuzzer_point)

		item = self.widgets['del_fuzz']
		item.connect('clicked', self.del_fuzzer_point)
		
		item = self.widgets['open']
		item.connect('clicked', self.open_file)

		item = self.widgets['open1']
		item.connect('activate', self.open_file)
		
		item = self.widgets['cbasis']
		item.connect('clicked', self.as_is_clicked)
		
		item = self.widgets['ok_fuzz']
		item.connect('clicked', self.ok_fuzz_clicked)
		
		self.logdataretrieval = gtk.TextBuffer(None)
		self.widgets['listeninglog'].set_buffer(self.logdataretrieval)

		fuzzutils.context["fuzzinglog"] = gtk.TextBuffer(None)
		self.widgets['fuzzinglog'].set_buffer(fuzzutils.context["fuzzinglog"])
		fuzzutils.context["fuzzinglog"].insert(fuzzutils.context["fuzzinglog"].get_end_iter(),"Click on 'Start' to begin fuzzing.\n\n")


		statusbar = self.widgets['statusbar1']
		fuzzutils.context["statusbar"] = statusbar.get_context_id("Fuzzer")
		self.push_statusbar("Ready")

#----------------------------------------------------------------------

	def create_fuzzer_points_list(self):

		model = gtk.ListStore(gobject.TYPE_UINT,gobject.TYPE_UINT,gobject.TYPE_UINT)
			
		treeview =  gtk.TreeView(model)
		treeview.id = "FuzzPointsList"
		treeview.set_rules_hint(True)
		treeview.set_search_column(COLUMN_TIME)

		sw = self.widgets['scrolledwindow7']
		sw.add(treeview)

		
		column = gtk.TreeViewColumn('Fuzz ID', gtk.CellRendererText(),
		                            text=COLUMN_ID)
		column.set_sort_column_id(COLUMN_ID)
		treeview.append_column(column)
		

		# columns
		column = gtk.TreeViewColumn('From', gtk.CellRendererText(),
		                            text=COLUMN_FROM)
		column.set_sort_column_id(COLUMN_FROM)
		treeview.append_column(column)
		
		column = gtk.TreeViewColumn('To', gtk.CellRendererText(),
		                            text=COLUMN_TO)
		column.set_sort_column_id(COLUMN_TO)
		treeview.append_column(column)
		
		treeview.show()
		
#----------------------------------------------------------------------

	def create_tree_view(self): # Creates a list with the saved requests after stopping listener
	
		data=[]
		pair=[1,'']
		data1 = fuzzutils.context["xmllog"].get_requests(fuzzutils.context["xmldoc"])
		for request in range(0, len(data1)):
			pair[0] = int(data1[request].attributes["ID"].value)
			pair[1] = str(data1[request].attributes["time"].value)
			data.append(pair[:])

		model = gtk.ListStore(gobject.TYPE_UINT,gobject.TYPE_STRING)
			
		for item in data:
			iter = model.append()
			model.set(iter, 0, item[0],	1, str(item[1]))	

		treeview =  gtk.TreeView(model)
		treeview.set_rules_hint(True)
		treeview.set_search_column(COLUMN_TIME)

		sw = self.widgets['scrolledwindow4']
		child = sw.get_child() 
		if child != None:
			sw.remove(child)
					
		sw.add(treeview)

		selection = treeview.get_selection()
		selection.set_mode(gtk.SELECTION_BROWSE)

		selection.connect('changed', self.selection_changed_cb)
		#selection.connect('double_clicked', self.on_setfuzz_clicked)
	

		column = gtk.TreeViewColumn('Request ID', gtk.CellRendererText(),
		                            text=COLUMN_ID)
		column.set_sort_column_id(COLUMN_ID)
		treeview.append_column(column)
		

		# columns
		column = gtk.TreeViewColumn('Time', gtk.CellRendererText(),
		                            text=COLUMN_TIME)
		column.set_sort_column_id(COLUMN_TIME)
		treeview.append_column(column)
		treeview.show()
		self.enablefuzzing()
		#by default, the first one is selected
		try:
			firstone = model.get_iter(0)
			selection.select_iter(firstone)
		except:
			pass

			
#----------------------------------------------------------------------		
		
	def push_statusbar(self, message):
		self.widgets['statusbar1'].push(fuzzutils.context["statusbar"], message)

#----------------------------------------------------------------------

	def pop_statusbar(self):
		self.widgets['statusbar1'].pop(fuzzutils.context["statusbar"])

#----------------------------------------------------------------------

	def load_request_list(self):
		pass

#----------------------------------------------------------------------

	def alert(self, type, text):
		message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, type, gtk.BUTTONS_OK, text)
		resp = message.run()
		if resp == gtk.RESPONSE_OK:
			message.destroy()

#----------------------------------------------------------------------

	def load_request(self, request_id): # loads request for fuzzing points
		mytextview = self.widgets['requesttext']
		mytextview.set_editable(0)
		mytextview.set_wrap_mode(2)
		mybuffer = mytextview.get_buffer()
		filename = str(request_id) + "req"
		try:
			infile = open(filename, "rb")
		except:
			return False

		if infile:
				#string = "%r" % infile.read()
				string = infile.read()
				mybuffer.set_text("%r"%string)
				result=""
				myhexview = self.widgets['hexview']
				myhexview.set_editable(0)
				myhexbuffer = myhexview.get_buffer()
				asciiresult=""
				
				for c in string[:]:
					result+= binascii.hexlify(c) + ' '
				infile.close()
				myhexbuffer.set_text(result)
		
				asciiresult=""
				myasciiview = self.widgets['asciiview']
				myasciiview.set_editable(0)
				myasciibuffer = myasciiview.get_buffer()
				asciiresult=""
				for c in string[:]:
					#print ord(c)
					if ord(c) in range(32,127) + [10,13]: # ascii printable characters 
						asciiresult += c
					else:
						asciiresult += "."
					myasciibuffer.set_text(asciiresult)
				#print asciiresult

#----------------------------------------------------------------------

	def selection_changed_cb(self, selection): # This def refreshes the request display when changing the request.
		model, iter = selection.get_selected()
		if not iter:
			return False
		
		name = model.get_value(iter, COLUMN_ID)
		self.current_request = name
		myrequest = fuzzutils.context["xmllog"].get_request(fuzzutils.context["xmldoc"], self.current_request-1)
		self.widgets['cbasis'].set_active(int(myrequest.attributes["as_is"].value))
		

		# to do: only display if window=visible, otherwise, skip this line
		self.load_request(name)
#		self.fuzz_points_show()
		
#----------------------------------------------------------------------
	def on_settings_delete_event(self, *args):
		if self.widgets['localserver'].get_text() != "":
			fuzzutils.context["local_host"] = self.widgets['localserver'].get_text() 
		if self.widgets['localport'].get_text() != "":
			fuzzutils.context["local_port"] = self.widgets['localport'].get_text()
		if self.widgets['remoteserver'].get_text() != "":
			fuzzutils.context["dest_host"] = self.widgets['remoteserver'].get_text()
		if self.widgets['remoteport'].get_text() != "":
			fuzzutils.context["dest_port"] = self.widgets['remoteport'].get_text()

		if fuzzutils.context.has_key("dest_host") and fuzzutils.context.has_key("dest_port") and fuzzutils.context.has_key("local_port") and fuzzutils.context.has_key("local_host"):
			self.widgets['listen'].set_sensitive(True)
			string = "[*] Listening service:\n\t - Local: " + fuzzutils.context["local_host"] + ":" + fuzzutils.context["local_port"] + "\n\t - Remote: " + fuzzutils.context["dest_host"] + ":" + fuzzutils.context["dest_port"] + "\n\n"
			self.logdataretrieval.insert(self.logdataretrieval.get_end_iter(),string)

		self.widgets['Settings'].hide()
		
		
		
		return 1

#----------------------------------------------------------------------

	def on_about_clicked(self, *args):
			self.widgets['aboutdialog1'].show()

#----------------------------------------------------------------------

	def on_help1_clicked(self, *args):
			self.widgets['helpdialog'].show()
		
#----------------------------------------------------------------------

	def on_settings_clicked(self, *args):
			self.widgets['Settings'].show()

#----------------------------------------------------------------------

	def on_dataretrievalbutton_clicked(self, *args):
			self.widgets['dataretrievaldialog'].show()

		
#----------------------------------------------------------------------

	def on_fuzzingbutton_clicked(self, *args):
			self.widgets['fuzzingdialog'].show()

#----------------------------------------------------------------------

	def on_aboutdialog_delete_event(self, *args):
		self.widgets['aboutdialog1'].hide()
		return 1
		
#----------------------------------------------------------------------

	def on_fuzzingdialog_delete_event(self, *args):
		self.widgets['fuzzingdialog'].hide()
		return 1

#----------------------------------------------------------------------
	def on_dataretrievaldialog_delete_event(self, *args):
		self.widgets['dataretrievaldialog'].hide()
		return 1

#----------------------------------------------------------------------
	def on_helpdialog_delete_event(self, *args):
		self.widgets['helpdialog'].hide()
		return 1

#----------------------------------------------------------------------


	def on_listen_clicked(self, *args):
		
		if not fuzzutils.context.has_key("dest_host") or not fuzzutils.context.has_key("dest_port") or not fuzzutils.context.has_key("local_port") or not fuzzutils.context.has_key("local_host"):
			#print 
			self.alert(gtk.MESSAGE_ERROR, "Please set forwarding information.")
		else:
			try: 
				self.push_statusbar("Forwarding conections...")
				reactor.listenTCP(int(fuzzutils.context["local_port"]), fuzzutils.portforward.ProxyFactory(fuzzutils.context["dest_host"], int(fuzzutils.context["dest_port"])))
		
				if not fuzzutils.context.has_key("logger"):
					fuzzutils.context["logger"] = fuzzutils.Log()
				#	os.chdir(fuzzutils.context["logger"].folder) It already changes working folder when created, so this is not needed
					fuzzutils.context["xmllog"] = fuzzutils.xmlfuzz()
					fuzzutils.context["xmldoc"], fuzzutils.context["xmlconv"] = fuzzutils.context["xmllog"].create_document(fuzzutils.context["local_host"], fuzzutils.context["local_port"], fuzzutils.context["dest_host"], str(fuzzutils.context["dest_port"]))
		#		else:	
		#			fuzzutils.context["xmldoc"] = fuzzutils.context["xmllog"].get_document()		
				self.widgets['listen'].set_sensitive(False)
				self.widgets['settings'].set_sensitive(False)
				self.widgets['stoplisten'].set_sensitive(True)
				self.widgets['dataretrievalok'].set_sensitive(False)
				self.widgets['open'].set_sensitive(False)
			
				self.logdataretrieval.insert(self.logdataretrieval.get_end_iter(),"[*] Forwarding traffic...\n")
				self.logdataretrieval.insert(self.logdataretrieval.get_end_iter(),"\t - Logging requests under '" + fuzzutils.context["logger"].folder + "' folder \n\n")

				reactor.run()


			except:
				self.alert(gtk.MESSAGE_ERROR, "Error setting listener: " + str(sys.exc_info()[0]) + " - " + str(sys.exc_info()[1]))
			
#----------------------------------------------------------------------

	def on_stoplisten_clicked(self, *args):
		try:
			self.push_statusbar("Stop forwarding...")
			reactor.stop()
			self.create_tree_view()
			fuzzutils.context["xmllog"].write_to_file(fuzzutils.context["xmldoc"])
			self.push_statusbar("Ready")

			self.widgets['listen'].set_sensitive(True)
			self.widgets['settings'].set_sensitive(True)
			self.widgets['stoplisten'].set_sensitive(False)
			self.widgets['dataretrievalok'].set_sensitive(True)
			self.widgets['open'].set_sensitive(True)
			self.logdataretrieval.insert(self.logdataretrieval.get_end_iter(),"[*] Forwarding service was stopped by the user.\n\n")
			
		except:
			self.alert(gtk.MESSAGE_ERROR, "Error: " + str(sys.exc_info()[0]) + " - " + str(sys.exc_info()[1]))
#----------------------------------------------------------------------

	def on_fuzz_clicked(self, *args):
		#try:
			if not fuzzutils.context.has_key("xmllog"):
				self.alert(gtk.MESSAGE_ERROR, "It's not possible to run a fuzzing session without previously retrieve information.")
			else:
				self.push_statusbar("Fuzzing...")
				fuzzutils.context["xmllog"].write_to_file(fuzzutils.context["xmldoc"])
				fuzzengine = fuzzutils.fuzzer()
				self.widgets['stopfuzzingbutton'].set_sensitive(True)				
				self.widgets['fuzz'].set_sensitive(False)				
				fuzzengine.run()
				self.widgets['stopfuzzingbutton'].set_sensitive(False)				
				self.widgets['fuzz'].set_sensitive(True)								
				self.push_statusbar("Fuzz finished.")
		#except:
		#	self.alert(gtk.MESSAGE_ERROR, "Error: " + str(sys.exc_info()[0]) + " - " + str(sys.exc_info()[1]))

#----------------------------------------------------------------------

	def on_stopfuzzingbutton_clicked(self, *args):
		fuzzutils.context['stopfuzzing']=1
		
#	def on_apply_clicked(self, *args):
#		pass


#----------------------------------------------------------------------
	def on_button_release(self, *args):

		mytextview = self.widgets['asciiview']
#		mytextview.set_editable(0)
		mybuffer = mytextview.get_buffer()
		data = mybuffer.get_selection_bounds()
		if data:
			tFrom = self.widgets['txtFrom']
			tTo = self.widgets['txtTo']
			tFrom.set_text(str(data[0].get_offset()))
			tTo.set_text(str(data[1].get_offset()))
			
#----------------------------------------------------------------------

	def on_Main_destroy_event(self, *args):
		gtk.main_quit()
		sys.exit(-1)

#----------------------------------------------------------------------

	def ok_fuzz_clicked(self, *args):
		self.widgets['FuzzPoints'].hide()

#----------------------------------------------------------------------

	def on_OK_clicked(self, *args):
		self.on_settings_delete_event()

#----------------------------------------------------------------------

	def on_setfuzz_clicked(self, *args):
		self.widgets['FuzzPoints'].show()

#----------------------------------------------------------------------

	def fuzz_points_show(self, *args):
		sw = self.widgets['scrolledwindow7']
		mylist = sw.get_children()
		model = mylist[0].get_model()

		for a in range(0,len(model)):
			del model[0]

		fuzzing_points = fuzzutils.context["xmllog"].get_fuzzs(fuzzutils.context["xmldoc"], self.current_request-1)
		for fuzz in range(0, len(fuzzing_points)):
			iter = model.append()
			model.set(iter, 0, int(fuzzing_points[fuzz].attributes["ID"].value),1, int(fuzzing_points[fuzz].attributes["from"].value), 2, int(fuzzing_points[fuzz].attributes["to"].value))
	
#----------------------------------------------------------------------		
		
	def add_fuzzer_point(self, *args):

		nto = self.widgets['txtTo']
		nfrom = self.widgets['txtFrom']		
		
		sw = self.widgets['scrolledwindow7']
		mylist = sw.get_children()
		model = mylist[0].get_model()		

		iter = model.append()
		model.set(iter, 0, len(model),	1,int(nfrom.get_text()), 2, int(nto.get_text()))	

		myrequest = fuzzutils.context["xmllog"].get_request(fuzzutils.context["xmldoc"], self.current_request-1)

		checkstackheap = int(self.widgets['checkstackheap'].get_active())
		checkstring = int(self.widgets['checkstring'].get_active())
		checkinteger = int(self.widgets['checkinteger'].get_active())		
				
		fuzzutils.context["xmllog"].add_fuzz(fuzzutils.context["xmldoc"], myrequest, len(model), nfrom.get_text(), nto.get_text(), checkstackheap, checkstring, checkinteger)
		fuzzutils.context["xmllog"].write_to_file(fuzzutils.context["xmldoc"])

#----------------------------------------------------------------------

	def del_fuzzer_point(self, *args):

		sw = self.widgets['scrolledwindow7']
		mylist = sw.get_children()
		
		selection = mylist[0].get_selection()
		selection.set_mode(gtk.SELECTION_BROWSE)

		model, iter = selection.get_selected()
		if not iter:
			return False
		model.remove(iter)

#----------------------------------------------------------------------

	def on_fuzzing_points_delete_event(self, *args):
		self.widgets['FuzzPoints'].hide()
		return 1

#----------------------------------------------------------------------	
	
	def open_file(self, *args):

		filter = gtk.FileFilter()
		filter.set_name('Fuzzing files')
		filter.add_pattern('fuzz.xml')
		self.widgets['filechooserdialog1'].add_filter(filter)

		response = self.widgets['filechooserdialog1'].run()
		self.widgets['filechooserdialog1'].hide()		

		if response == gtk.RESPONSE_OK:
			fuzzutils.context["logger"] = fuzzutils.Log(self.widgets['filechooserdialog1'].get_current_folder())
			fuzzutils.context["xmllog"] = fuzzutils.xmlfuzz()
			fuzzutils.context["xmldoc"], fuzzutils.context["xmlconv"] = fuzzutils.context["xmllog"].get_document(self.widgets['filechooserdialog1'].get_filename())

			fuzzutils.context["local_host"], fuzzutils.context["local_port"], fuzzutils.context["dest_host"], fuzzutils.context["dest_port"] = fuzzutils.context["xmllog"].get_network_info(fuzzutils.context["xmldoc"])

			self.widgets['localserver'].set_text(fuzzutils.context["local_host"])
			self.widgets['localport'].set_text(fuzzutils.context["local_port"])
			self.widgets['remoteserver'].set_text(fuzzutils.context["dest_host"])
			self.widgets['remoteport'].set_text(fuzzutils.context["dest_port"])
			try:
				self.create_tree_view()
			except:
				self.alert(gtk.MESSAGE_ERROR, "Error retrieving information from file")
				return '-1'				
			self.enablefuzzing()
			self.on_dataretrievaldialog_delete_event()
		
#----------------------------------------------------------------------

	def as_is_clicked(self, *args):
		myrequest = fuzzutils.context["xmllog"].get_request(fuzzutils.context["xmldoc"], self.current_request-1)
		if self.widgets['cbasis'].get_active():
			fuzzutils.context["xmllog"].add_as_is(fuzzutils.context["xmldoc"], myrequest)
		else:
			fuzzutils.context["xmllog"].del_as_is(fuzzutils.context["xmldoc"], myrequest)
		#fuzzutils.context["xmllog"].write_to_screen(fuzzutils.context["xmldoc"])	
			
	
#----------------------------------------------------------------------

	def enablefuzzing(self, *args):
		self.widgets['fuzzingbutton'].set_sensitive(True)
		self.widgets['setfuzz'].set_sensitive(True)
		self.widgets['cbasis'].set_sensitive(True)		



def main(argv):
		w = taof()
		w.widgets['Main'].show()
		gtk.main()

#----------------------------------------------------------------------

if __name__ == '__main__':
		main(sys.argv)
